精华内容
下载资源
问答
  • tomcat 开机自启动配置

    2017-10-12 22:55:00
    tomcat 开机自启动配置在nginx 集群中需要使用到tomcat ,要安装tomcat 首要保证已经安装了jdk。服务器中现有apache-tomcat-7.0.61.tar.gz,解压后,就可以启动。为了不需要每次开机都启动tomcat 我们需要配置tomcat...


    Tomcat 开机自启动配置

    在nginx 集群中需要使用到tomcat ,要安装tomcat 首要保证已经安装了jdk。服务器中现有apache-tomcat.tar.gz,解压后,就可以启动。为了不需要每次开机都启动tomcat 我们需要配置tomcat开机自启。

    Linux下tomcat开机自动启动有两种方法,一种是简单,一种是复杂而又专业的shell。下面我们分别介绍这两种方法。

    1.修改系统文件

    1.修改/etc/rc.d/rc.local

    vi /etc/rc.d/rc.local   
    

    2.添加下面两行脚本,记住是两行,仅仅第二行不行,必须加第一行。在/etc/rc.d/rc.local文件最后加上:

    export JAVA_HOME=/usr/java/jdk1.7.0_60  
    /usr/local/tomcat/bin/startup.sh start  
    

    说明:
    /usr/java/jdk1.7.0_60 是jdk安装目录
    /usr/local/tomcat是tomcat安装的目录

    3.注意:修改rc.local文件为可执行

    chmod +x  rc.local  
    

    重启完成。

    2.shell脚本启动

    众所周知,在Linux中设置开机自启动的服务,需要在/etc/rcX.d下挂载。除此之外还需要在/etc/init.d下些启动脚本。其实很简单,先export出所需要的环境变量,例如JAVA_HOME,JRE_HOME, CATALINA_HOME, CATALINA_BASE什么的,然后再直接调用$CATALINA_HOME/bin/startup.sh就能成功启动。

    第一步:我们在/etc/init.d下新建一个文件tomcat(需要在root权限下操作)

    vi /etc/init.d/tomcat 
    

    写下如下代码,tomcat自启动脚本:

    #!/bin/sh  
    # chkconfig: 345 99 10  
    # description: Auto-starts tomcat  
    # /etc/init.d/tomcatd  
    # Tomcat auto-start  
    # Source function library.  
    #. /etc/init.d/functions  
    # source networking configuration.  
    #. /etc/sysconfig/network  
    RETVAL=0  
    export JAVA_HOME=/usr/java/jdk1.7.0_60  
    export JRE_HOME=/usr/java/jdk1.7.0_60/jre  
    export CATALINA_HOME=/usr/local/tomcat  
    export CATALINA_BASE=/usr/local/tomcat  
    start()  
    {  
            if [ -f $CATALINA_HOME/bin/startup.sh ];  
              then  
                echo $"Starting Tomcat"  
                    $CATALINA_HOME/bin/startup.sh  
                RETVAL=$?  
                echo " OK"  
                return $RETVAL  
            fi  
    }  
    stop()  
    {  
            if [ -f $CATALINA_HOME/bin/shutdown.sh ];  
              then  
                echo $"Stopping Tomcat"  
                    $CATALINA_HOME/bin/shutdown.sh  
                RETVAL=$?  
                sleep 1  
                ps -fwwu root | grep tomcat|grep -v grep | grep -v PID | awk '{print $2}'|xargs kill -9  
                echo " OK"  
                # [ $RETVAL -eq 0 ] && rm -f /var/lock/...  
                return $RETVAL  
            fi  
    }  
    
    case "$1" in  
     start)   
            start  
            ;;  
     stop)    
            stop  
            ;;  
    
     restart)  
             echo $"Restaring Tomcat"  
             $0 stop  
             sleep 1  
             $0 start  
             ;;  
     *)  
            echo $"Usage: $0 {start|stop|restart}"  
            exit 1  
            ;;  
    esac  
    exit $RETVAL  

    这里特别提醒注意这一句ps -fwwu root | grep tomcat|grep -v grep | grep -v PID | awk ‘{print $2}’|xargs kill -9,熟悉Linux命令的人应该都清楚这句话的意义,这里就简单说下前半部分,查询root用户下tomcat的进程PID,个人根据实际情况修改。

    第二步:保存退出之后,给其增加可执行权限

    chmod +x /etc/init.d/tomcat 
    

    第三步:挂载

    将这个shell文件的link连到/etc/rc2.d/目录下。linux的/etc/rcX.d/目录中的数字代表开机启动时不同的run level,也就是启动的顺序,Ubuntu9.10下有0-5六个level,不能随便连到其他目录下,可能在那个目录中的程序启动时Tomcat所需要的一些库尚未被加载,用ln命令将tomcat的链接链过去:sudo ln -s /etc/init.d/tomcat /etc/rc2.d/S16Tomcat。rcX.d目录下的命名规则是很有讲究的,更具不同需要可能是S开头,也可能是K开头,之后的数字代表他们的启动顺序,详细看各自目录下的Readme文件。

    ln -s /etc/init.d/tomcat /etc/rc2.d/S16Tomcat  
    

    第四步:设置脚本开机自启动

    chkconfig --add tomcat  
    

    第五步:验证

    执行 sudo reboot。重启之后就会发现,Tomcat已经成功运行了。

    重启tomcat。完成。




    展开全文
  • tomcat开机自启动配置

    2015-10-12 15:06:53
    1、把下面的代码保存为tomcat文件,并让它成为可执行文件 chmod 755 tomcat. #!/bin/bash # # kenny kenny.zhou@tom.com # /etc/rc.d/init.d/tomcat # init script for tomcat precesses # # processname: ...

    1、把下面的代码保存为tomcat文件,并让它成为可执行文件 chmod 755 tomcat.
    #!/bin/bash
    #
    # kenny kenny.zhou@tom.com
    # /etc/rc.d/init.d/tomcat
    # init script for tomcat precesses
    #
    # processname: tomcat
    # description: tomcat is a j2se server
    # chkconfig: 2345 86 16
    # description: Start up the Tomcat servlet engine.

    if [ -f /etc/init.d/functions ]; then
    . /etc/init.d/functions
    elif [ -f /etc/rc.d/init.d/functions ]; then
    . /etc/rc.d/init.d/functions
    else
    echo -e "/atomcat: unable to locate functions lib. Cannot continue."
    exit -1
    fi

    RETVAL=$?
    CATALINA_HOME="/usr/local/tomcat"

    case "$1" in
    start)
    if [ -f $CATALINA_HOME/bin/startup.sh ];
    then
    echo $"Starting Tomcat"
    $CATALINA_HOME/bin/startup.sh
    fi
    ;;
    stop)
    if [ -f $CATALINA_HOME/bin/shutdown.sh ];
    then
    echo $"Stopping Tomcat"
    $CATALINA_HOME/bin/shutdown.sh
    fi
    ;;
    *)
    echo $"Usage: $0 {start|stop}"
    exit 1
    ;;
    esac

    exit $RETVAL

    2、将tomcat文件拷贝到/etc/init.d/下,并运行:chkconfig --add tomcat

    3、在tomcat/bin/catalina.sh文件中加入以下语句:
    export JAVA_HOME=/YOURPATH/tomcat/jdk
    export CATALINA_HOME=/YOURPATH/tomcat
    export CATALINA_BASE=/YOURPATH/tomcat
    export CATALINA_TMPDIR=/YOURPATH/tomcat/temp

    启动tomcat: service tomcat start
    停止tomcat: service tomcat stop 


    有一点值得关注的是,我配置的时候是按照上面的配置的,还没成功,后来经过查找网络发现,第三步中的几个环境变量要放到开头。然后就好了。 

    展开全文
  • 1.建立一个tomcat文件(名字可以随便命名相当于是一个服务的名字) 2.将以下代码考入tomcat文件中 #!/bin/bash # chkconfig: 2345 10 90 # description: Starts and Stops the Tomcat daemon. # /etc/init.d/...

     

    1.建立一个tomcat文件(名字可以随便命名相当于是一个服务的名字)

     

    2.将以下代码考入tomcat文件中

    #!/bin/bash

    # chkconfig: 2345 10 90

    # description: Starts and Stops the Tomcat daemon.

    # /etc/init.d/tomcatd

    # Tomcat auto-start

    # Source function library.

    #. /etc/init.d/functions

    # source networking configuration.

    #. /etc/sysconfig/network

    RETVAL=0

    export JAVA_HOME=/usr/local/jdk1.8.0_121

    export JRE_HOME=/usr/local/jdk1.8.0_121/jre

    #自己配置的tomcat路径

    export CATALINA_HOME=/mnt/drore/kaifayizu/xxsddq/cms

    export CATALINA_BASE=/mnt/drore/kaifayizu/xxsddq/cms

    start()

    {

            if [ -f $CATALINA_HOME/bin/startup.sh ];

              then

                echo $"Starting Tomcat"

                    $CATALINA_HOME/bin/startup.sh

                RETVAL=$?

                echo " OK"

                return $RETVAL

            fi

    }

    stop()

    {

            if [ -f $CATALINA_HOME/bin/shutdown.sh ];

              then

                echo $"Stopping Tomcat"

                    $CATALINA_HOME/bin/shutdown.sh

                RETVAL=$?

                sleep 1

                ps -fwwu root | grep tomcat|grep -v grep | grep -v PID | awk '{print $2}'|xargs kill -9

                echo " OK"

                # [ $RETVAL -eq 0 ] && rm -f /var/lock/...

                return $RETVAL

            fi

    }

     

    case "$1" in

    start)

            start

            ;;

    stop) 

            stop

            ;;

                                                   

    restart)

             echo $"Restaring Tomcat"

             $0 stop

             sleep 1

             $0 start

             ;;

    *)

            echo $"Usage: $0 {start|stop|restart}"

            exit 1

            ;;

    esac

    exit $RETVAL

     

     

     

    3.修改环境变量里面的

    export JAVA_HOME=/usr/java/jdk1.7.0_60  //java路径

    export JRE_HOME=/usr/java/jdk1.7.0_60/jre  

    export CATALINA_HOME=/usr/local/tomcat  

    export CATALINA_BASE=/usr/local/tomcat   //自己配置的tomcat路径

     

    完成后将tomcat文件放在/etc/rc.d/init.d  目录下面

    给其增加可执行权限 chmod +x /etc/init.d/tomcat  

     

    4.这里特别提醒注意这一句ps -fwwu root | grep tomcat|grep -v grep | grep -v PID | awk '{print $2}'|xargs kill -9,熟悉Linux命令的人应该都清楚这句话的意义,这里就简单说下前半部分,查询root用户下tomcat的进程PID,个人根据实际情况修改。 

    chkconfig --add tomcat 设置服务运行级别

     

    chkconfig --list   查看服务列表

     

     

    测试服务是否成功

    service tomcat start   启动

    service tomcat stop    停止

    service tomcat restart  重启

    service tomcat status  服务状态

    展开全文
  • Nginx开机自启动 安装好之后每次开机都要这样启动就很麻烦,所以就采取了开机自启动 首先通过vi在init.d下创建nginx文件 vi /etc/init.d/nginx 下面几个地方是我列出的需要根据情况修改的 pidfile需要和nginx...

    Nginx开机自启动

    安装好之后每次开机都要这样启动就很麻烦,所以就采取了开机自启动
    首先通过vi在init.d下创建nginx文件

    vi /etc/init.d/nginx

    下面几个地方是我列出的需要根据情况修改的
    pidfile需要和nginx.conf一致,使用nginx目录下的文件
    lockfile的文件目录是用mkdir新建创建出来的,用来避免权限访问的情况

    nginx="/usr/local/nginx/sbin/nginx"
    NGINX_CONF_FILE="/usr/local/nginx/conf/nginx.conf"
    
    # pidfile:     /var/run/nginx.pid
    lockfile=/usr/local/nginx/lock/nginx

    脚本是官方写的

    #!/bin/sh 
    # 
    # nginx - this script starts and stops the nginx daemon 
    # 
    # chkconfig:   - 85 15 
    # description: Nginx is an HTTP(S) server, HTTP(S) reverse \ 
    #               proxy and IMAP/POP3 proxy server 
    # processname: nginx 
    # config:      /etc/nginx/nginx.conf 
    # config:      /etc/sysconfig/nginx 
    # pidfile:     /usr/local/nginx/logs/nginx.pid 
    
    # Source function library. 
    . /etc/rc.d/init.d/functions 
    
    # Source networking configuration. 
    . /etc/sysconfig/network 
    
    # Check that networking is up. 
    [ "$NETWORKING" = "no" ] && exit 0 
    
    nginx="/usr/local/nginx/sbin/nginx" 
    prog=$(basename $nginx) 
    
    NGINX_CONF_FILE="/usr/local/nginx/conf/nginx.conf" 
    
    [ -f /etc/sysconfig/nginx ] && . /etc/sysconfig/nginx 
    
    lockfile=/usr/local/nginx/lock/nginx
    
    start() { 
        [ -x $nginx ] || exit 5 
        [ -f $NGINX_CONF_FILE ] || exit 6 
        echo -n $"Starting $prog: " 
        daemon $nginx -c $NGINX_CONF_FILE 
        retval=$? 
        echo 
        [ $retval -eq 0 ] && touch $lockfile 
        return $retval 
    } 
    
    stop() { 
        echo -n $"Stopping $prog: " 
        killproc $prog -QUIT 
        retval=$? 
        echo 
        [ $retval -eq 0 ] && rm -f $lockfile 
        return $retval 
         killall -9 nginx 
    } 
    
    restart() { 
        configtest || return $? 
        stop 
        sleep 1 
        start 
    } 
    
    reload() { 
        configtest || return $? 
        echo -n $"Reloading $prog: " 
        killproc $nginx -HUP 
    RETVAL=$? 
        echo 
    } 
    
    force_reload() { 
        restart 
    } 
    
    configtest() { 
    $nginx -t -c $NGINX_CONF_FILE 
    } 
    
    rh_status() { 
        status $prog 
    } 
    
    rh_status_q() { 
        rh_status >/dev/null 2>&1 
    } 
    
    case "$1" in 
        start) 
            rh_status_q && exit 0 
        $1 
            ;; 
        stop) 
            rh_status_q || exit 0 
            $1 
            ;; 
        restart|configtest) 
            $1 
            ;; 
        reload) 
            rh_status_q || exit 7 
            $1 
            ;; 
        force-reload) 
            force_reload 
            ;; 
        status) 
            rh_status 
            ;; 
        condrestart|try-restart) 
            rh_status_q || exit 0 
                ;; 
        *)    
          echo $"Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload|configtest}" 
            exit 2 
    
    esac  
    

    首先我们需要设置文件的执行权限

    chmod a+x /etc/init.d/nginx 

    通过

    chkconfig --add /etc/init.d/nginx

    将服务加入chkconfig后即可用

    service nginx start
    service nginx stop

    进行开启关闭

    然后设置开机自启动

    chkconfig nginx on

    Tomcat开机自启动

    首先通过vi在init.d下创建tomcat文件

    vi /etc/init.d/tomcat

    同样需要关注的地方只有一个,修改为对应目录即可

    CATALINA_HOME=/usr/local/tomcat 
    JAVA_HOME=/usr/local/jdk1.8.0_162

    脚本如下

    #!/bin/sh
    # chkconfig: 2345 10 90 
    # description:Tomcat service 
    # Licensed to the Apache Software Foundation (ASF) under one or more
    # contributor license agreements.  See the NOTICE file distributed with
    # this work for additional information regarding copyright ownership.
    # The ASF licenses this file to You under the Apache License, Version 2.0
    # (the "License"); you may not use this file except in compliance with
    # the License.  You may obtain a copy of the License at
    #
    #     http://www.apache.org/licenses/LICENSE-2.0
    #
    # Unless required by applicable law or agreed to in writing, software
    # distributed under the License is distributed on an "AS IS" BASIS,
    # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    # See the License for the specific language governing permissions and
    # limitations under the License.
    
    # -----------------------------------------------------------------------------
    # Control Script for the CATALINA Server
    #
    # Environment Variable Prerequisites
    #
    #   Do not set the variables in this script. Instead put them into a script
    #   setenv.sh in CATALINA_BASE/bin to keep your customizations separate.
    #
    #   CATALINA_HOME   May point at your Catalina "build" directory.
    #
    #   CATALINA_BASE   (Optional) Base directory for resolving dynamic portions
    #                   of a Catalina installation.  If not present, resolves to
    #                   the same directory that CATALINA_HOME points to.
    #
    #   CATALINA_OUT    (Optional) Full path to a file where stdout and stderr
    #                   will be redirected.
    #                   Default is $CATALINA_BASE/logs/catalina.out
    #
    #   CATALINA_OPTS   (Optional) Java runtime options used when the "start",
    #                   "run" or "debug" command is executed.
    #                   Include here and not in JAVA_OPTS all options, that should
    #                   only be used by Tomcat itself, not by the stop process,
    #                   the version command etc.
    #                   Examples are heap size, GC logging, JMX ports etc.
    #
    #   CATALINA_TMPDIR (Optional) Directory path location of temporary directory
    #                   the JVM should use (java.io.tmpdir).  Defaults to
    #                   $CATALINA_BASE/temp.
    #
    #   JAVA_HOME       Must point at your Java Development Kit installation.
    #                   Required to run the with the "debug" argument.
    #
    #   JRE_HOME        Must point at your Java Runtime installation.
    #                   Defaults to JAVA_HOME if empty. If JRE_HOME and JAVA_HOME
    #                   are both set, JRE_HOME is used.
    #
    #   JAVA_OPTS       (Optional) Java runtime options used when any command
    #                   is executed.
    #                   Include here and not in CATALINA_OPTS all options, that
    #                   should be used by Tomcat and also by the stop process,
    #                   the version command etc.
    #                   Most options should go into CATALINA_OPTS.
    #
    #   JAVA_ENDORSED_DIRS (Optional) Lists of of colon separated directories
    #                   containing some jars in order to allow replacement of APIs
    #                   created outside of the JCP (i.e. DOM and SAX from W3C).
    #                   It can also be used to update the XML parser implementation.
    #                   Note that Java 9 no longer supports this feature.
    #                   Defaults to $CATALINA_HOME/endorsed.
    #
    #   JPDA_TRANSPORT  (Optional) JPDA transport used when the "jpda start"
    #                   command is executed. The default is "dt_socket".
    #
    #   JPDA_ADDRESS    (Optional) Java runtime options used when the "jpda start"
    #                   command is executed. The default is 8000.
    #
    #   JPDA_SUSPEND    (Optional) Java runtime options used when the "jpda start"
    #                   command is executed. Specifies whether JVM should suspend
    #                   execution immediately after startup. Default is "n".
    #
    #   JPDA_OPTS       (Optional) Java runtime options used when the "jpda start"
    #                   command is executed. If used, JPDA_TRANSPORT, JPDA_ADDRESS,
    #                   and JPDA_SUSPEND are ignored. Thus, all required jpda
    #                   options MUST be specified. The default is:
    #
    #                   -agentlib:jdwp=transport=$JPDA_TRANSPORT,
    #                       address=$JPDA_ADDRESS,server=y,suspend=$JPDA_SUSPEND
    #
    #   JSSE_OPTS       (Optional) Java runtime options used to control the TLS
    #                   implementation when JSSE is used. Default is:
    #                   "-Djdk.tls.ephemeralDHKeySize=2048"
    #
    #   CATALINA_PID    (Optional) Path of the file which should contains the pid
    #                   of the catalina startup java process, when start (fork) is
    #                   used
    #
    #   LOGGING_CONFIG  (Optional) Override Tomcat's logging config file
    #                   Example (all one line)
    #                   LOGGING_CONFIG="-Djava.util.logging.config.file=$CATALINA_BASE/conf/logging.properties"
    #
    #   LOGGING_MANAGER (Optional) Override Tomcat's logging manager
    #                   Example (all one line)
    #                   LOGGING_MANAGER="-Djava.util.logging.manager=org.apache.juli.ClassLoaderLogManager"
    #
    #   USE_NOHUP       (Optional) If set to the string true the start command will
    #                   use nohup so that the Tomcat process will ignore any hangup
    #                   signals. Default is "false" unless running on HP-UX in which
    #                   case the default is "true"
    # -----------------------------------------------------------------------------
    
    # OS specific support.  $var _must_ be set to either true or false.
    CATALINA_HOME=/usr/local/tomcat 
    JAVA_HOME=/usr/local/jdk1.8.0_162
    cygwin=false
    darwin=false
    os400=false
    hpux=false
    case "`uname`" in
    CYGWIN*) cygwin=true;;
    Darwin*) darwin=true;;
    OS400*) os400=true;;
    HP-UX*) hpux=true;;
    esac
    
    # resolve links - $0 may be a softlink
    PRG="$0"
    
    while [ -h "$PRG" ]; do
      ls=`ls -ld "$PRG"`
      link=`expr "$ls" : '.*-> \(.*\)$'`
      if expr "$link" : '/.*' > /dev/null; then
        PRG="$link"
      else
        PRG=`dirname "$PRG"`/"$link"
      fi
    done
    
    # Get standard environment variables
    PRGDIR=`dirname "$PRG"`
    
    # Only set CATALINA_HOME if not already set
    [ -z "$CATALINA_HOME" ] && CATALINA_HOME=`cd "$PRGDIR/.." >/dev/null; pwd`
    
    # Copy CATALINA_BASE from CATALINA_HOME if not already set
    [ -z "$CATALINA_BASE" ] && CATALINA_BASE="$CATALINA_HOME"
    
    # Ensure that any user defined CLASSPATH variables are not used on startup,
    # but allow them to be specified in setenv.sh, in rare case when it is needed.
    CLASSPATH=
    
    if [ -r "$CATALINA_BASE/bin/setenv.sh" ]; then
      . "$CATALINA_BASE/bin/setenv.sh"
    elif [ -r "$CATALINA_HOME/bin/setenv.sh" ]; then
      . "$CATALINA_HOME/bin/setenv.sh"
    fi
    
    # For Cygwin, ensure paths are in UNIX format before anything is touched
    if $cygwin; then
      [ -n "$JAVA_HOME" ] && JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
      [ -n "$JRE_HOME" ] && JRE_HOME=`cygpath --unix "$JRE_HOME"`
      [ -n "$CATALINA_HOME" ] && CATALINA_HOME=`cygpath --unix "$CATALINA_HOME"`
      [ -n "$CATALINA_BASE" ] && CATALINA_BASE=`cygpath --unix "$CATALINA_BASE"`
      [ -n "$CLASSPATH" ] && CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
    fi
    
    # For OS400
    if $os400; then
      # Set job priority to standard for interactive (interactive - 6) by using
      # the interactive priority - 6, the helper threads that respond to requests
      # will be running at the same priority as interactive jobs.
      COMMAND='chgjob job('$JOBNAME') runpty(6)'
      system $COMMAND
    
      # Enable multi threading
      export QIBM_MULTI_THREADED=Y
    fi
    
    # Get standard Java environment variables
    if $os400; then
      # -r will Only work on the os400 if the files are:
      # 1. owned by the user
      # 2. owned by the PRIMARY group of the user
      # this will not work if the user belongs in secondary groups
      . "$CATALINA_HOME"/bin/setclasspath.sh
    else
      if [ -r "$CATALINA_HOME"/bin/setclasspath.sh ]; then
        . "$CATALINA_HOME"/bin/setclasspath.sh
      else
        echo "Cannot find $CATALINA_HOME/bin/setclasspath.sh"
        echo "This file is needed to run this program"
        exit 1
      fi
    fi
    
    # Add on extra jar files to CLASSPATH
    if [ ! -z "$CLASSPATH" ] ; then
      CLASSPATH="$CLASSPATH":
    fi
    CLASSPATH="$CLASSPATH""$CATALINA_HOME"/bin/bootstrap.jar
    
    if [ -z "$CATALINA_OUT" ] ; then
      CATALINA_OUT="$CATALINA_BASE"/logs/catalina.out
    fi
    
    if [ -z "$CATALINA_TMPDIR" ] ; then
      # Define the java.io.tmpdir to use for Catalina
      CATALINA_TMPDIR="$CATALINA_BASE"/temp
    fi
    
    # Add tomcat-juli.jar to classpath
    # tomcat-juli.jar can be over-ridden per instance
    if [ -r "$CATALINA_BASE/bin/tomcat-juli.jar" ] ; then
      CLASSPATH=$CLASSPATH:$CATALINA_BASE/bin/tomcat-juli.jar
    else
      CLASSPATH=$CLASSPATH:$CATALINA_HOME/bin/tomcat-juli.jar
    fi
    
    # Bugzilla 37848: When no TTY is available, don't output to console
    have_tty=0
    if [ "`tty`" != "not a tty" ]; then
        have_tty=1
    fi
    
    # For Cygwin, switch paths to Windows format before running java
    if $cygwin; then
      JAVA_HOME=`cygpath --absolute --windows "$JAVA_HOME"`
      JRE_HOME=`cygpath --absolute --windows "$JRE_HOME"`
      CATALINA_HOME=`cygpath --absolute --windows "$CATALINA_HOME"`
      CATALINA_BASE=`cygpath --absolute --windows "$CATALINA_BASE"`
      CATALINA_TMPDIR=`cygpath --absolute --windows "$CATALINA_TMPDIR"`
      CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
      JAVA_ENDORSED_DIRS=`cygpath --path --windows "$JAVA_ENDORSED_DIRS"`
    fi
    
    if [ -z "$JSSE_OPTS" ] ; then
      JSSE_OPTS="-Djdk.tls.ephemeralDHKeySize=2048"
    fi
    JAVA_OPTS="$JAVA_OPTS $JSSE_OPTS"
    
    # Set juli LogManager config file if it is present and an override has not been issued
    if [ -z "$LOGGING_CONFIG" ]; then
      if [ -r "$CATALINA_BASE"/conf/logging.properties ]; then
        LOGGING_CONFIG="-Djava.util.logging.config.file=$CATALINA_BASE/conf/logging.properties"
      else
        # Bugzilla 45585
        LOGGING_CONFIG="-Dnop"
      fi
    fi
    
    if [ -z "$LOGGING_MANAGER" ]; then
      LOGGING_MANAGER="-Djava.util.logging.manager=org.apache.juli.ClassLoaderLogManager"
    fi
    
    # Java 9 no longer supports the java.endorsed.dirs
    # system property. Only try to use it if
    # JAVA_ENDORSED_DIRS was explicitly set
    # or CATALINA_HOME/endorsed exists.
    ENDORSED_PROP=ignore.endorsed.dirs
    if [ -n "$JAVA_ENDORSED_DIRS" ]; then
        ENDORSED_PROP=java.endorsed.dirs
    fi
    if [ -d "$CATALINA_HOME/endorsed" ]; then
        ENDORSED_PROP=java.endorsed.dirs
    fi
    
    # Uncomment the following line to make the umask available when using the
    # org.apache.catalina.security.SecurityListener
    #JAVA_OPTS="$JAVA_OPTS -Dorg.apache.catalina.security.SecurityListener.UMASK=`umask`"
    
    if [ -z "$USE_NOHUP" ]; then
        if $hpux; then
            USE_NOHUP="true"
        else
            USE_NOHUP="false"
        fi
    fi
    unset _NOHUP
    if [ "$USE_NOHUP" = "true" ]; then
        _NOHUP=nohup
    fi
    
    # Add the JAVA 9 specific start-up parameters required by Tomcat
    JDK_JAVA_OPTIONS="$JDK_JAVA_OPTIONS --add-opens=java.base/java.lang=ALL-UNNAMED"
    JDK_JAVA_OPTIONS="$JDK_JAVA_OPTIONS --add-opens=java.rmi/sun.rmi.transport=ALL-UNNAMED"
    export JDK_JAVA_OPTIONS
    
    # ----- Execute The Requested Command -----------------------------------------
    
    # Bugzilla 37848: only output this if we have a TTY
    if [ $have_tty -eq 1 ]; then
      echo "Using CATALINA_BASE:   $CATALINA_BASE"
      echo "Using CATALINA_HOME:   $CATALINA_HOME"
      echo "Using CATALINA_TMPDIR: $CATALINA_TMPDIR"
      if [ "$1" = "debug" ] ; then
        echo "Using JAVA_HOME:       $JAVA_HOME"
      else
        echo "Using JRE_HOME:        $JRE_HOME"
      fi
      echo "Using CLASSPATH:       $CLASSPATH"
      if [ ! -z "$CATALINA_PID" ]; then
        echo "Using CATALINA_PID:    $CATALINA_PID"
      fi
    fi
    
    if [ "$1" = "jpda" ] ; then
      if [ -z "$JPDA_TRANSPORT" ]; then
        JPDA_TRANSPORT="dt_socket"
      fi
      if [ -z "$JPDA_ADDRESS" ]; then
        JPDA_ADDRESS="8000"
      fi
      if [ -z "$JPDA_SUSPEND" ]; then
        JPDA_SUSPEND="n"
      fi
      if [ -z "$JPDA_OPTS" ]; then
        JPDA_OPTS="-agentlib:jdwp=transport=$JPDA_TRANSPORT,address=$JPDA_ADDRESS,server=y,suspend=$JPDA_SUSPEND"
      fi
      CATALINA_OPTS="$JPDA_OPTS $CATALINA_OPTS"
      shift
    fi
    
    if [ "$1" = "debug" ] ; then
      if $os400; then
        echo "Debug command not available on OS400"
        exit 1
      else
        shift
        if [ "$1" = "-security" ] ; then
          if [ $have_tty -eq 1 ]; then
            echo "Using Security Manager"
          fi
          shift
          exec "$_RUNJDB" "$LOGGING_CONFIG" $LOGGING_MANAGER $JAVA_OPTS $CATALINA_OPTS \
            -D$ENDORSED_PROP="$JAVA_ENDORSED_DIRS" \
            -classpath "$CLASSPATH" \
            -sourcepath "$CATALINA_HOME"/../../java \
            -Djava.security.manager \
            -Djava.security.policy=="$CATALINA_BASE"/conf/catalina.policy \
            -Dcatalina.base="$CATALINA_BASE" \
            -Dcatalina.home="$CATALINA_HOME" \
            -Djava.io.tmpdir="$CATALINA_TMPDIR" \
            org.apache.catalina.startup.Bootstrap "$@" start
        else
          exec "$_RUNJDB" "$LOGGING_CONFIG" $LOGGING_MANAGER $JAVA_OPTS $CATALINA_OPTS \
            -D$ENDORSED_PROP="$JAVA_ENDORSED_DIRS" \
            -classpath "$CLASSPATH" \
            -sourcepath "$CATALINA_HOME"/../../java \
            -Dcatalina.base="$CATALINA_BASE" \
            -Dcatalina.home="$CATALINA_HOME" \
            -Djava.io.tmpdir="$CATALINA_TMPDIR" \
            org.apache.catalina.startup.Bootstrap "$@" start
        fi
      fi
    
    elif [ "$1" = "run" ]; then
    
      shift
      if [ "$1" = "-security" ] ; then
        if [ $have_tty -eq 1 ]; then
          echo "Using Security Manager"
        fi
        shift
        eval exec "\"$_RUNJAVA\"" "\"$LOGGING_CONFIG\"" $LOGGING_MANAGER $JAVA_OPTS $CATALINA_OPTS \
          -D$ENDORSED_PROP="\"$JAVA_ENDORSED_DIRS\"" \
          -classpath "\"$CLASSPATH\"" \
          -Djava.security.manager \
          -Djava.security.policy=="\"$CATALINA_BASE/conf/catalina.policy\"" \
          -Dcatalina.base="\"$CATALINA_BASE\"" \
          -Dcatalina.home="\"$CATALINA_HOME\"" \
          -Djava.io.tmpdir="\"$CATALINA_TMPDIR\"" \
          org.apache.catalina.startup.Bootstrap "$@" start
      else
        eval exec "\"$_RUNJAVA\"" "\"$LOGGING_CONFIG\"" $LOGGING_MANAGER $JAVA_OPTS $CATALINA_OPTS \
          -D$ENDORSED_PROP="\"$JAVA_ENDORSED_DIRS\"" \
          -classpath "\"$CLASSPATH\"" \
          -Dcatalina.base="\"$CATALINA_BASE\"" \
          -Dcatalina.home="\"$CATALINA_HOME\"" \
          -Djava.io.tmpdir="\"$CATALINA_TMPDIR\"" \
          org.apache.catalina.startup.Bootstrap "$@" start
      fi
    
    elif [ "$1" = "start" ] ; then
    
      if [ ! -z "$CATALINA_PID" ]; then
        if [ -f "$CATALINA_PID" ]; then
          if [ -s "$CATALINA_PID" ]; then
            echo "Existing PID file found during start."
            if [ -r "$CATALINA_PID" ]; then
              PID=`cat "$CATALINA_PID"`
              ps -p $PID >/dev/null 2>&1
              if [ $? -eq 0 ] ; then
                echo "Tomcat appears to still be running with PID $PID. Start aborted."
                echo "If the following process is not a Tomcat process, remove the PID file and try again:"
                ps -f -p $PID
                exit 1
              else
                echo "Removing/clearing stale PID file."
                rm -f "$CATALINA_PID" >/dev/null 2>&1
                if [ $? != 0 ]; then
                  if [ -w "$CATALINA_PID" ]; then
                    cat /dev/null > "$CATALINA_PID"
                  else
                    echo "Unable to remove or clear stale PID file. Start aborted."
                    exit 1
                  fi
                fi
              fi
            else
              echo "Unable to read PID file. Start aborted."
              exit 1
            fi
          else
            rm -f "$CATALINA_PID" >/dev/null 2>&1
            if [ $? != 0 ]; then
              if [ ! -w "$CATALINA_PID" ]; then
                echo "Unable to remove or write to empty PID file. Start aborted."
                exit 1
              fi
            fi
          fi
        fi
      fi
    
      shift
      touch "$CATALINA_OUT"
      if [ "$1" = "-security" ] ; then
        if [ $have_tty -eq 1 ]; then
          echo "Using Security Manager"
        fi
        shift
        eval $_NOHUP "\"$_RUNJAVA\"" "\"$LOGGING_CONFIG\"" $LOGGING_MANAGER $JAVA_OPTS $CATALINA_OPTS \
          -D$ENDORSED_PROP="\"$JAVA_ENDORSED_DIRS\"" \
          -classpath "\"$CLASSPATH\"" \
          -Djava.security.manager \
          -Djava.security.policy=="\"$CATALINA_BASE/conf/catalina.policy\"" \
          -Dcatalina.base="\"$CATALINA_BASE\"" \
          -Dcatalina.home="\"$CATALINA_HOME\"" \
          -Djava.io.tmpdir="\"$CATALINA_TMPDIR\"" \
          org.apache.catalina.startup.Bootstrap "$@" start \
          >> "$CATALINA_OUT" 2>&1 "&"
    
      else
        eval $_NOHUP "\"$_RUNJAVA\"" "\"$LOGGING_CONFIG\"" $LOGGING_MANAGER $JAVA_OPTS $CATALINA_OPTS \
          -D$ENDORSED_PROP="\"$JAVA_ENDORSED_DIRS\"" \
          -classpath "\"$CLASSPATH\"" \
          -Dcatalina.base="\"$CATALINA_BASE\"" \
          -Dcatalina.home="\"$CATALINA_HOME\"" \
          -Djava.io.tmpdir="\"$CATALINA_TMPDIR\"" \
          org.apache.catalina.startup.Bootstrap "$@" start \
          >> "$CATALINA_OUT" 2>&1 "&"
    
      fi
    
      if [ ! -z "$CATALINA_PID" ]; then
        echo $! > "$CATALINA_PID"
      fi
    
      echo "Tomcat started."
    
    elif [ "$1" = "stop" ] ; then
    
      shift
    
      SLEEP=5
      if [ ! -z "$1" ]; then
        echo $1 | grep "[^0-9]" >/dev/null 2>&1
        if [ $? -gt 0 ]; then
          SLEEP=$1
          shift
        fi
      fi
    
      FORCE=0
      if [ "$1" = "-force" ]; then
        shift
        FORCE=1
      fi
    
      if [ ! -z "$CATALINA_PID" ]; then
        if [ -f "$CATALINA_PID" ]; then
          if [ -s "$CATALINA_PID" ]; then
            kill -0 `cat "$CATALINA_PID"` >/dev/null 2>&1
            if [ $? -gt 0 ]; then
              echo "PID file found but no matching process was found. Stop aborted."
              exit 1
            fi
          else
            echo "PID file is empty and has been ignored."
          fi
        else
          echo "\$CATALINA_PID was set but the specified file does not exist. Is Tomcat running? Stop aborted."
          exit 1
        fi
      fi
    
      eval "\"$_RUNJAVA\"" $LOGGING_MANAGER $JAVA_OPTS \
        -D$ENDORSED_PROP="\"$JAVA_ENDORSED_DIRS\"" \
        -classpath "\"$CLASSPATH\"" \
        -Dcatalina.base="\"$CATALINA_BASE\"" \
        -Dcatalina.home="\"$CATALINA_HOME\"" \
        -Djava.io.tmpdir="\"$CATALINA_TMPDIR\"" \
        org.apache.catalina.startup.Bootstrap "$@" stop
    
      # stop failed. Shutdown port disabled? Try a normal kill.
      if [ $? != 0 ]; then
        if [ ! -z "$CATALINA_PID" ]; then
          echo "The stop command failed. Attempting to signal the process to stop through OS signal."
          kill -15 `cat "$CATALINA_PID"` >/dev/null 2>&1
        fi
      fi
    
      if [ ! -z "$CATALINA_PID" ]; then
        if [ -f "$CATALINA_PID" ]; then
          while [ $SLEEP -ge 0 ]; do
            kill -0 `cat "$CATALINA_PID"` >/dev/null 2>&1
            if [ $? -gt 0 ]; then
              rm -f "$CATALINA_PID" >/dev/null 2>&1
              if [ $? != 0 ]; then
                if [ -w "$CATALINA_PID" ]; then
                  cat /dev/null > "$CATALINA_PID"
                  # If Tomcat has stopped don't try and force a stop with an empty PID file
                  FORCE=0
                else
                  echo "The PID file could not be removed or cleared."
                fi
              fi
              echo "Tomcat stopped."
              break
            fi
            if [ $SLEEP -gt 0 ]; then
              sleep 1
            fi
            if [ $SLEEP -eq 0 ]; then
              echo "Tomcat did not stop in time."
              if [ $FORCE -eq 0 ]; then
                echo "PID file was not removed."
              fi
              echo "To aid diagnostics a thread dump has been written to standard out."
              kill -3 `cat "$CATALINA_PID"`
            fi
            SLEEP=`expr $SLEEP - 1 `
          done
        fi
      fi
    
      KILL_SLEEP_INTERVAL=5
      if [ $FORCE -eq 1 ]; then
        if [ -z "$CATALINA_PID" ]; then
          echo "Kill failed: \$CATALINA_PID not set"
        else
          if [ -f "$CATALINA_PID" ]; then
            PID=`cat "$CATALINA_PID"`
            echo "Killing Tomcat with the PID: $PID"
            kill -9 $PID
            while [ $KILL_SLEEP_INTERVAL -ge 0 ]; do
                kill -0 `cat "$CATALINA_PID"` >/dev/null 2>&1
                if [ $? -gt 0 ]; then
                    rm -f "$CATALINA_PID" >/dev/null 2>&1
                    if [ $? != 0 ]; then
                        if [ -w "$CATALINA_PID" ]; then
                            cat /dev/null > "$CATALINA_PID"
                        else
                            echo "The PID file could not be removed."
                        fi
                    fi
                    echo "The Tomcat process has been killed."
                    break
                fi
                if [ $KILL_SLEEP_INTERVAL -gt 0 ]; then
                    sleep 1
                fi
                KILL_SLEEP_INTERVAL=`expr $KILL_SLEEP_INTERVAL - 1 `
            done
            if [ $KILL_SLEEP_INTERVAL -lt 0 ]; then
                echo "Tomcat has not been killed completely yet. The process might be waiting on some system call or might be UNINTERRUPTIBLE."
            fi
          fi
        fi
      fi
    
    elif [ "$1" = "configtest" ] ; then
    
        eval "\"$_RUNJAVA\"" $LOGGING_MANAGER $JAVA_OPTS \
          -D$ENDORSED_PROP="\"$JAVA_ENDORSED_DIRS\"" \
          -classpath "\"$CLASSPATH\"" \
          -Dcatalina.base="\"$CATALINA_BASE\"" \
          -Dcatalina.home="\"$CATALINA_HOME\"" \
          -Djava.io.tmpdir="\"$CATALINA_TMPDIR\"" \
          org.apache.catalina.startup.Bootstrap configtest
        result=$?
        if [ $result -ne 0 ]; then
            echo "Configuration error detected!"
        fi
        exit $result
    
    elif [ "$1" = "version" ] ; then
    
        "$_RUNJAVA"   \
          -classpath "$CATALINA_HOME/lib/catalina.jar" \
          org.apache.catalina.util.ServerInfo
    
    else
    
      echo "Usage: catalina.sh ( commands ... )"
      echo "commands:"
      if $os400; then
        echo "  debug             Start Catalina in a debugger (not available on OS400)"
        echo "  debug -security   Debug Catalina with a security manager (not available on OS400)"
      else
        echo "  debug             Start Catalina in a debugger"
        echo "  debug -security   Debug Catalina with a security manager"
      fi
      echo "  jpda start        Start Catalina under JPDA debugger"
      echo "  run               Start Catalina in the current window"
      echo "  run -security     Start in the current window with security manager"
      echo "  start             Start Catalina in a separate window"
      echo "  start -security   Start in a separate window with security manager"
      echo "  stop              Stop Catalina, waiting up to 5 seconds for the process to end"
      echo "  stop n            Stop Catalina, waiting up to n seconds for the process to end"
      echo "  stop -force       Stop Catalina, wait up to 5 seconds and then use kill -KILL if still running"
      echo "  stop n -force     Stop Catalina, wait up to n seconds and then use kill -KILL if still running"
      echo "  configtest        Run a basic syntax check on server.xml - check exit code for result"
      echo "  version           What version of tomcat are you running?"
      echo "Note: Waiting for the process to end and use of the -force option require that \$CATALINA_PID is defined"
      exit 1
    
    fi
    

    首先我们需要设置文件的执行权限

    chmod 755 tomcat

    通过

    chkconfig --add /etc/init.d/tomcat

    将服务加入chkconfig后即可用

    service tomcat start
    service tomcat stop

    进行开启关闭

    然后设置开机自启动

    chkconfig tomcat on
    展开全文
  • vi /etc/rc.d/rc.local 在文件中加入:/tomcat/bin/startup.sh(Tomcat安装在linux的路径)保存退出
  • Linux 配置tomcat开机自启动

    千次阅读 2019-03-19 13:48:53
    Linux 配置tomcat开机自启动 注:请自行下载安装配置tomcat的服务器环境本文档仅介绍如何配置tomcat的开机自动启动 1:进入到tomcat/bin目录下,输入命令:vi startup.sh 2:在startup.sh的文件开头的地方添加...
  • CentOS7配置Tomcat开机自动启动 CentOS7配置Tomcat开机启动 安装Tomcat 1.下载tomcat7解压到目录即可 修改startup.sh启动文件 1.startup.sh是tomcat的启动文件2.修改之前先备份一下3.在startup.s...
  • Ubuntu配置tomcat开机自动启动 为了重启机器时相关服务可以自启动,我们可以这么做: 在开机的时候就启动一个服务,比如tomcat。 1、将tomcat目录下/bin中的catalina.sh拷贝到/etc/init.d下,并重命名为tomcat ...
  • 因为我使用tomcat的做事是为了启动solr,所以我就配置tomcat开机自启动。 首先我们要写一个service。 vim /etc/systemd/system/tomcat.service [Unit] Description=Tomcat9027 After=syslog.target network....
  • Tomcat开机自动启动

    2017-09-26 10:33:36
    tomcat开机自动启动的原理是注册系统服务。 绿色版tomcat在配置好Java环境以后直接运行bin下面的startup.bat就能够正常启动,但是...需要tomcat开机自动启动。下面简单介绍一如何在windows下面开机自动启动
  • tomcat开机自启动

    2017-08-01 19:52:19
      绿色版tomcat在配置好Java环境以后直接运行bin下面的startup.bat就能够正常启动,但是... 首先、在设置tomcat开机自动启动之前首先需要配置Java环境,配置Java环境不在赘述。  然后、新建变量:CATALINA_
  • Linux下配置tomcat开机自启动 1、写一个tomcat脚本,内容如下,设置其权限为755,放在/etc/init.d/目录下 #!/bin/bash## /etc/init.d/tomcat# init script for tomcat precesses## processname: tomcat# ...
  • 一、防火墙相关配置 二、配置Tomcat自启动 三、配置Tomcat可登录

空空如也

空空如也

1 2 3 4 5 ... 20
收藏数 490
精华内容 196
关键字:

tomcat开机自启动配置